import math

def velocity_menu():
    print("Velocity Calculator")
    print("1: Final velocity (v = vi + a*t)")
    print("2: Final velocity from displacement (v = sqrt(vi^2 + 2*a*s))")
    print("3: Constant velocity (v = s / t)")
    print("4: Tangential velocity in circular motion (v = ω * r)")
    print("5: Free-fall velocity (v = sqrt(2*g*h))")
    print("6: Velocity from work-energy theorem (v = sqrt((2*W)/m))")
    print("7: Velocity from centripetal acceleration (v = sqrt(ac * r))")
    choice = input("Choose a method (1-7): ")
    return choice

def velocity_from_acceleration():
    print("\nMethod 1: v = vi + a*t")
    vi = float(input("Enter initial velocity (vi): "))
    a = float(input("Enter acceleration (a): "))
    t = float(input("Enter time (t): "))
    v = vi + a * t
    print("Final velocity (v) =", v)

def velocity_from_displacement():
    print("\nMethod 2: v = sqrt(vi^2 + 2*a*s)")
    vi = float(input("Enter initial velocity (vi): "))
    a = float(input("Enter acceleration (a): "))
    s = float(input("Enter displacement (s): "))
    inside = vi**2 + 2 * a * s
    if inside < 0:
        print("No real solution because the expression under the square root is negative.")
    else:
        v = math.sqrt(inside)
        print("Final velocity (v) =", v)

def constant_velocity():
    print("\nMethod 3: v = s / t")
    s = float(input("Enter displacement (s): "))
    t = float(input("Enter time (t): "))
    if t == 0:
        print("Time cannot be zero.")
    else:
        v = s / t
        print("Constant velocity (v) =", v)

def tangential_velocity():
    print("\nMethod 4: v = ω * r")
    omega = float(input("Enter angular velocity (ω): "))
    r = float(input("Enter radius (r): "))
    v = omega * r
    print("Tangential velocity (v) =", v)

def free_fall_velocity():
    print("\nMethod 5: v = sqrt(2*g*h)")
    g = float(input("Enter gravitational acceleration (g) [~9.81 m/s²]: "))
    h = float(input("Enter height (h): "))
    if g < 0 or h < 0:
        print("Gravitational acceleration and height should be non-negative.")
    else:
        v = math.sqrt(2 * g * h)
        print("Free-fall velocity (v) =", v)

def velocity_from_work_energy():
    print("\nMethod 6: v = sqrt((2*W)/m)")
    W = float(input("Enter work done (W): "))
    m = float(input("Enter mass (m): "))
    if m <= 0:
        print("Mass must be positive.")
    elif W < 0:
        print("Work should be non-negative for kinetic energy conversion.")
    else:
        v = math.sqrt((2 * W) / m)
        print("Velocity (v) =", v)

def centripetal_velocity():
    print("\nMethod 7: v = sqrt(ac * r)")
    ac = float(input("Enter centripetal acceleration (ac): "))
    r = float(input("Enter radius (r): "))
    if ac < 0 or r < 0:
        print("Acceleration and radius should be non-negative.")
    else:
        v = math.sqrt(ac * r)
        print("Centripetal velocity (v) =", v)

def main():
    choice = velocity_menu()
    if choice == '1':
        velocity_from_acceleration()
    elif choice == '2':
        velocity_from_displacement()
    elif choice == '3':
        constant_velocity()
    elif choice == '4':
        tangential_velocity()
    elif choice == '5':
        free_fall_velocity()
    elif choice == '6':
        velocity_from_work_energy()
    elif choice == '7':
        centripetal_velocity()
    else:
        print("Invalid choice.")

# Automatically run the program
main()
